Index: /trunk/src/slib.c
===================================================================
--- /trunk/src/slib.c	(revision 584)
+++ /trunk/src/slib.c	(revision 1)
@@ -2077,40 +1801,27 @@
   /* Make entry.
    */
-  /* cppcheck-suppress arrayIndexOutOfBoundsCond */
   if (fd >= MAXFD)
      {
-	sl_close_fd(FIL__, __LINE__, fd);
+	close(fd);
 	SL_IRETURN(SL_TOOMANY, _("sl_open_file"));
      }
 
-  if (ofiles[fd] != NULL) /* stale entry */
-    {
-      /*
-      sl_close_fd(FIL__, __LINE__, fd);
-      SL_IRETURN(SL_EINTERNAL09, _("sl_open_file"));
-      */
-      sl_strlcpy(stale_orig_file, ofiles[fd]->ofile, sizeof(stale_orig_file));
-      stale_orig_line = ofiles[fd]->oline;
-
-      if (ofiles[fd]->content)
-	sh_string_destroy(&(ofiles[fd]->content));
-      (void) free (ofiles[fd]->path);
-      (void) free (ofiles[fd]);
+   if (ofiles[fd] != NULL)
+    {
+      close(fd);
+      SL_IRETURN(SL_EINTERNAL, _("sl_open_file"));
+    }
+
+  if ( (ofiles[fd] = (SL_OFILE *) malloc(sizeof(SL_OFILE))) == NULL)
+    {
+      close(fd);
+      SL_IRETURN(SL_EMEM, _("sl_open_file"));
+    }
+
+   if ( (ofiles[fd]->path = (char *) malloc( strlen(filename)+1) ) == NULL)
+    {
+      free(ofiles[fd]);
       ofiles[fd] = NULL;
-    }
-
-  if ( (ofiles[fd] = calloc(1,sizeof(SL_OFILE))) == NULL)
-    {
-      sl_close_fd(FIL__, __LINE__, fd);
-      SL_IRETURN(SL_EMEM, _("sl_open_file"));
-    }
-
-  len = sl_strlen(filename)+1;
-
-  if ( (ofiles[fd]->path = calloc(1,len) ) == NULL)
-    {
-      free (ofiles[fd]);
-      ofiles[fd] = NULL;
-      sl_close_fd(FIL__, __LINE__, fd);
+      close(fd);
       SL_IRETURN(SL_EMEM, _("sl_open_file"));
     }
@@ -2124,55 +1835,17 @@
       (void) free (ofiles[fd]->path);
       (void) free (ofiles[fd]);
-      ofiles[fd] = NULL;
-      sl_close_fd(FIL__, __LINE__, fd);
+      close(fd);
       SL_IRETURN(ticket, _("sl_open_file"));
     }
 
-  sl_strlcpy (ofiles[fd]->path, filename, len);
-  ofiles[fd]->ticket  = ticket;
-  ofiles[fd]->fd      = fd;
-  ofiles[fd]->content = NULL;
-  ofiles[fd]->stream  = NULL;
-  ofiles[fd]->flush   = S_FALSE;
-
-  sl_strlcpy(ofiles[fd]->ofile, ofile, SL_OFILE_SIZE);
-  ofiles[fd]->oline = oline;
+  strcpy (ofiles[fd]->path, filename);                    /* Known to fit  */
+  ofiles[fd]->ticket = ticket;
+  ofiles[fd]->fd     = fd;
 
   SL_IRETURN(ticket, _("sl_open_file"));
 }
 
-FILE * sl_stream (SL_TICKET ticket, char * mode)
-{
-  int    fd;
-
-  if (SL_ISERROR(fd = sl_read_ticket(ticket)))
-    return (NULL);
-
-  if (ofiles[fd] == NULL || fd != ofiles[fd]->fd || 
-      ticket != ofiles[fd]->ticket || fd < 0)
-    return (NULL);
-
-  if (!ofiles[fd]->stream)
-    ofiles[fd]->stream = fdopen(fd, mode);
-
-  return ofiles[fd]->stream;
-}
-
-int get_the_fd (SL_TICKET ticket)
-{
-  int fd;
-
-  if (SL_ISERROR(fd = sl_read_ticket(ticket)))
-    return (fd);
-
-  if (ofiles[fd] == NULL || fd != ofiles[fd]->fd || 
-      ticket != ofiles[fd]->ticket || fd < 0)
-    return (SL_EINTERNAL10);
-
-  return (fd);
-}
-
 static
-int check_fname_priv (const char * fname, int priv)
+int check_fname_priv (char * fname, int priv)
 {
   SL_ENTER(_("check_fname_priv"));
@@ -2180,10 +1853,9 @@
     SL_IRETURN(SL_ENULL, _("check_fname_priv"));
   if (priv != SL_YESPRIV && priv != SL_NOPRIV)
-    SL_IRETURN(SL_EINTERNAL11, _("check_fname_priv"));
+    SL_IRETURN(SL_EINTERNAL, _("check_fname_priv"));
   SL_IRETURN(SL_ENONE, _("check_fname_priv"));
 }
   
-SL_TICKET sl_open_write (const char * ofile, int oline,
-			 const char * fname, int priv)
+SL_TICKET sl_open_write (char * fname, int priv)
 {
   long status;
@@ -2193,10 +1865,9 @@
     SL_IRETURN(status, _("sl_open_write"));
 
-  status = sl_open_file(ofile, oline, fname, SL_OPEN_FOR_WRITE, priv);
+  status = sl_open_file(fname, SL_OPEN_FOR_WRITE, priv);
   SL_IRETURN(status, _("sl_open_write"));
 }
 
-SL_TICKET sl_open_read (const char * ofile, int oline,
-			const char * fname, int priv)
+SL_TICKET sl_open_read (char * fname, int priv)
 {
   long status;
@@ -2211,61 +1882,9 @@
     }
 
-  status = sl_open_file(ofile, oline, fname, SL_OPEN_FOR_READ, priv);
+  status = sl_open_file(fname, SL_OPEN_FOR_READ, priv);
   SL_IRETURN(status, _("sl_open_read"));
 }
 
-#if defined(HAVE_POSIX_FADVISE) && defined(HAVE_MINCORE) && defined(POSIX_FADV_DONTNEED)
-static int sl_check_mincore(int fd)
-{
-  /* Idea from Tobias Oetiker (http://insights.oetiker.ch/linux/fadvise.html)
-   */
-  struct stat fbuf;
-  int retval = -1;
-
-  if (0 == fstat(fd, &fbuf))
-    {
-      void *f_map;
-      
-      f_map = mmap((void *)0, fbuf.st_size, PROT_NONE, MAP_SHARED, fd, 0);
-      if (MAP_FAILED != f_map)
-	{
-	  extern int sh_unix_pagesize(void);
-	  size_t i;
-	  size_t page_size    = sh_unix_pagesize();
-	  size_t vec_size     = (fbuf.st_size+page_size-1)/page_size;
-	  unsigned char * vec = calloc(1, vec_size);
-
-	  if (vec)
-	    {
-	      mincore(f_map, fbuf.st_size, vec);
-	      /* imax = fbuf.st_size/page_size; */
-	      for (i = 0; i <= vec_size; ++i)
-		{
-		  if (vec[i]&1)
-		    {
-		      goto incore;
-		    }
-		}
-	      retval = 0;
-	    incore:
-	      free(vec);
-	    }
-	  munmap(f_map, fbuf.st_size);
-	}
-    }
-  return retval;
-}
-#endif
-
-static int sl_drop_cache = S_FALSE;
-
-int sl_set_drop_cache(const char * str)
-{
-  extern int sh_util_flagval(const char * c, int * fval);
-  return sh_util_flagval(str, &sl_drop_cache);
-}
-
-SL_TICKET sl_open_fastread (const char * ofile, int oline,
-			    const char * fname, int priv)
+SL_TICKET sl_open_fastread (char * fname, int priv)
 {
   long status;
@@ -2275,25 +1894,9 @@
     SL_IRETURN(status, _("sl_open_read"));
 
-  status = sl_open_file(ofile, oline, fname, SL_OPEN_FOR_FASTREAD, priv);
-
-#if defined(HAVE_POSIX_FADVISE) && defined(HAVE_MINCORE) && defined(POSIX_FADV_DONTNEED)
-
-  if (S_FALSE != sl_drop_cache && !SL_ISERROR(status))
-    {
-      int fd = get_the_fd(status);
-      if (fd >= 0)
-	{
-	  if (0 == sl_check_mincore(fd))
-	    ofiles[fd]->flush = S_TRUE;
-	}
-    }
-
-#endif
-
+  status = sl_open_file(fname, SL_OPEN_FOR_FASTREAD, priv);
   SL_IRETURN(status, _("sl_open_fastread"));
 }
 
-SL_TICKET sl_open_rdwr (const char * ofile, int oline,
-			const char * fname, int priv)
+SL_TICKET sl_open_rdwr (char * fname, int priv)
 {
   long status;
@@ -2303,10 +1906,9 @@
     SL_IRETURN(status, _("sl_open_rdwr"));
 
-  status = sl_open_file(ofile, oline, fname, SL_OPEN_FOR_RDWR, priv);
+  status = sl_open_file(fname, SL_OPEN_FOR_RDWR, priv);
   SL_IRETURN(status, _("sl_open_rdwr"));
 }
 
-SL_TICKET sl_open_safe_rdwr (const char * ofile, int oline,
-			     const char * fname, int priv)
+SL_TICKET sl_open_safe_rdwr (char * fname, int priv)
 {
   long status;
@@ -2316,10 +1918,9 @@
     SL_IRETURN(status, _("sl_open_safe_rdwr"));
 
-  status = sl_open_file(ofile, oline, fname, SL_OPEN_SAFE_RDWR, priv);
+  status = sl_open_file(fname, SL_OPEN_SAFE_RDWR, priv);
   SL_IRETURN(status, _("sl_open_safe_rdwr"));
 }
 
-SL_TICKET sl_open_write_trunc (const char * ofile, int oline,
-			       const char * fname, int priv)
+SL_TICKET sl_open_write_trunc (char * fname, int priv)
 {
   long status;
@@ -2329,10 +1930,9 @@
     SL_IRETURN(status, _("sl_open_write_trunc"));
 
-  status = sl_open_file(ofile, oline, fname, SL_OPEN_FOR_WTRUNC, priv);
+  status = sl_open_file(fname, SL_OPEN_FOR_WTRUNC, priv);
   SL_IRETURN(status, _("sl_open_write_trunc"));
 }
 
-SL_TICKET sl_open_rdwr_trunc (const char * ofile, int oline,
-			      const char * fname, int priv)
+SL_TICKET sl_open_rdwr_trunc (char * fname, int priv)
 {
   long status;
@@ -2342,10 +1942,10 @@
     SL_IRETURN(status, _("sl_open_rdwr_trunc"));
 
-  status = sl_open_file(ofile, oline, fname, SL_OPEN_FOR_RWTRUNC, priv);
+  status = sl_open_file(fname, SL_OPEN_FOR_RWTRUNC, priv);
   SL_IRETURN(status, _("sl_open_rdwr_trunc"));
 }
 
 
-int sl_init_content (SL_TICKET ticket, size_t size)
+int get_the_fd (SL_TICKET ticket)
 {
   int fd;
@@ -2354,62 +1954,12 @@
     return (fd);
 
-  if (ofiles[fd] == NULL || fd != ofiles[fd]->fd || 
-      ticket != ofiles[fd]->ticket || fd < 0)
-    return (SL_EINTERNAL12);
-
-  if (ofiles[fd]->content)
-    sh_string_destroy(&(ofiles[fd]->content));
-  ofiles[fd]->content = sh_string_new(size);
-
-  return SL_ENONE;
-}
-
-sh_string * sl_get_content (SL_TICKET ticket)
-{
-  int fd;
-
-  if (SL_ISERROR(fd = sl_read_ticket(ticket)))
-    return (NULL);
-
-  if (ofiles[fd] == NULL || fd != ofiles[fd]->fd || 
-      ticket != ofiles[fd]->ticket || fd < 0)
-    return (NULL);
-
-  return (ofiles[fd]->content);
-}
-
-int sl_lock (SL_TICKET ticket)
-{
-  int fd;
-  struct flock lock;
-  int retval;
- 
-  SL_ENTER(_("sl_lock"));
-
-  if (SL_ISERROR(fd = get_the_fd (ticket)))
-    SL_IRETURN(fd, _("sl_lock"));
-
-  lock.l_type   = F_WRLCK;
-  lock.l_whence = SEEK_SET;
-  lock.l_start  = 0;
-  lock.l_len    = 0;
-
-  /* F_SETLK returns if the lock cannot be obtained */
-  do {
-    retval = fcntl(fd, F_SETLK, &lock);
-  } while (retval < 0 && errno == EINTR);
-
-  if (retval < 0 && errno == EBADF)
-    SL_IRETURN(SL_ETICKET, _("sl_lock"));
-  else if (retval < 0)
-    SL_IRETURN(SL_EBADFILE, _("sl_lock"));
-  else
-    SL_IRETURN(SL_ENONE, _("sl_lock"));
- }
- 
+  if (ofiles[fd] == NULL || fd != ofiles[fd]->fd || fd < 0)
+    return (SL_EINTERNAL);
+  return (fd);
+}
+
 int sl_close (SL_TICKET ticket) 
 {
   register int fd;
-  FILE * fp = NULL;
 
   SL_ENTER(_("sl_close"));
@@ -2418,81 +1968,21 @@
     SL_IRETURN(fd, _("sl_close"));
 
-  if (ofiles[fd] != NULL)
-    {
-#if defined(HAVE_POSIX_FADVISE) && defined(HAVE_MINCORE) && defined(POSIX_FADV_DONTNEED)
-      if (ofiles[fd]->flush == S_TRUE)
-	{
-	  posix_fadvise(fd, 0, 0, POSIX_FADV_DONTNEED);
-	}
-#endif
-      if (ofiles[fd]->content)
-	sh_string_destroy(&(ofiles[fd]->content));
-      (void) free (ofiles[fd]->path);
-      fp = ofiles[fd]->stream;
-      (void) free (ofiles[fd]);
-      ofiles[fd] = NULL;
-    }
-
   /* This may fail, but what to do then ?
    */
-  if (fp)
-    {
-      if (0 != fclose (fp)) /* within sl_close */
-	{
-	  TPT((0, FIL__, __LINE__, 
-	       _("msg=<Error fclosing file.>, fd=<%d>, err=<%s>\n"), 
-	       fd, strerror(errno)));
-	  SL_IRETURN(SL_ECLOSE, _("sl_close")); 
-	}
-    }
-  else
-    {
-      if (0 != close(fd)) /* within sl_close */
-	{
-	  TPT((0, FIL__, __LINE__, 
-	       _("msg=<Error closing file.>, fd=<%d>, err=<%s>\n"), 
-	       fd, strerror(errno)));
-	  SL_IRETURN(SL_ECLOSE, _("sl_close")); 
-	}
+  if (0 != close(fd) && ofiles[fd] != NULL)
+    {
+      TPT((0, FIL__, __LINE__, 
+	   _("msg=<Error closing file.>, path=<%s>, fd=<%d>\n"), 
+	   ofiles[fd]->path, fd));
+    }
+
+  if (ofiles[fd] != NULL)
+    {
+      (void) free(ofiles[fd]->path);
+      (void) free(ofiles[fd]);
+      ofiles[fd] = NULL;
     }
 
   SL_IRETURN(SL_ENONE, _("sl_close")); 
-}
-
-int sl_close_fd (const char * file, int line, int fd)
-{
-  int ret = -1;
-
-  SL_ENTER(_("sl_close_fd"));
-
-  if (fd >= 0 && fd < MAXFD && ofiles[fd] != NULL) /* stale ofiles[fd] handle */
-    {
-      sl_strlcpy(badfd_orig_file, file, sizeof(badfd_orig_file));
-      badfd_orig_line = line;
-    }
-
-  ret = close(fd); /* within sl_close_fd wrapper */
-
-  SL_IRETURN(ret, _("sl_close_fd")); 
-}
-
-int sl_fclose (const char * file, int line, FILE * fp)
-{
-  int ret = -1;
-  int fd;
-
-  SL_ENTER(_("sl_fclose"));
-
-  fd = fileno(fp);
-
-  if (fd >= 0 && fd < MAXFD && ofiles[fd] != NULL) /* stale ofiles[fd] handle */
-    {
-      sl_strlcpy(badfd_orig_file, file, sizeof(badfd_orig_file));
-      badfd_orig_line = line;
-    }
-
-  ret = fclose(fp); /* within sl_fclose wrapper */
-
-  SL_IRETURN(ret, _("sl_fclose")); 
 }
 
@@ -2503,9 +1993,7 @@
       if (ofiles[fd] != NULL && fd != except)
 	{
-	  if (ofiles[fd]->content)
-	    sh_string_destroy(&(ofiles[fd]->content));
 	  if (ofiles[fd]->path != NULL)
-	    (void) free (ofiles[fd]->path);
-	  (void) free (ofiles[fd]);
+	    (void) free(ofiles[fd]->path);
+	  (void) free(ofiles[fd]);
 	  ofiles[fd] = NULL;
 	}
@@ -2515,17 +2003,4 @@
 }
 
-int sl_dropall_dirty(int fd, int except)
-{
-  while (fd < MAXFD)
-    {
-      if (ofiles[fd] != NULL && fd != except)
-	{
-	  ofiles[fd] = NULL;
-	}
-      ++fd;
-    }
-  return 0;
-}
-
 
 int sl_unlink (SL_TICKET ticket) 
@@ -2606,36 +2081,14 @@
 }
 
-int sl_read_timeout_prep (SL_TICKET ticket)
-{
-  int fd;
-  int sflags;
-
-  SL_ENTER(_("sl_read_timeout_prep"));
-
-  if (SL_ISERROR(fd = get_the_fd(ticket)))
-    {
-      TPT(( 0, FIL__, __LINE__, _("msg=<ticket error> errno=<%d>"), fd));
-      SL_IRETURN(fd, _("sl_read_timeout_prep"));
-    }
-
-  /* set to non-blocking mode 
-   */
-  sflags = retry_fcntl(FIL__, __LINE__, fd, F_GETFL, 0);
-  retry_fcntl(FIL__, __LINE__, fd, F_SETFL, sflags | O_NONBLOCK);
-
-  SL_IRETURN(SL_ENONE, _("sl_read_timeout_prep"));
-}
-
-
-static int sl_read_timeout_fd_int (int fd, void * buf_in, size_t count, 
-				   int timeout, int is_nonblocking, int once)
-{
-  int sflags = 0;
+
+int sl_read_timeout (SL_TICKET ticket, void * buf_in, size_t count, 
+		     int timeout)
+{
   fd_set readfds;
   struct timeval tv;
-  /* int sflags; */
+  int sflags;
   int retval;
-  int error;
-
+
+  int    fd;
   int    byteread = 0;
   int    bytes    = 0;
@@ -2647,13 +2100,27 @@
   extern volatile int sig_termfast;
  
-  if (is_nonblocking == S_FALSE)
-    {
-      /* set to non-blocking mode 
-       */
-      sflags = retry_fcntl(FIL__, __LINE__, fd, F_GETFL, 0);
-      retry_fcntl(FIL__, __LINE__, fd, F_SETFL, sflags | O_NONBLOCK);
+  if (count < 1)
+    {
+      TPT(( 0, FIL__, __LINE__, _("msg=<range error>")));
+      return(SL_ERANGE);
+    }
+  if (buf_in == NULL)
+    {
+      TPT(( 0, FIL__, __LINE__, _("msg=<null buffer>")));
+      return (SL_ENULL);
+    }
+
+  if (SL_ISERROR(fd = get_the_fd(ticket)))
+    {
+      TPT(( 0, FIL__, __LINE__, _("msg=<ticket error> errno=<%d>"), fd));
+      return (fd);
     }
 
   buf = (char *) buf_in;
+
+  /* set to non-blocking mode 
+   */
+  sflags = retry_fcntl(FIL__, __LINE__, fd, F_GETFL, 0);
+  retry_fcntl(FIL__, __LINE__, fd, F_SETFL, sflags | O_NONBLOCK);
 
   tstart = time(NULL);
@@ -2662,6 +2129,26 @@
   while (count > 0)
     {
+
+      if (sig_termfast == 1) 
+	{
+	  retry_fcntl(FIL__, __LINE__, fd, F_SETFL, 
+		      sflags & ~O_NONBLOCK);
+	  return (SL_EREAD);
+	}
+	  
       FD_ZERO(&readfds);
       FD_SET(fd, &readfds);
+
+      if (tdiff >= timeout)
+	{
+	  retry_fcntl(FIL__, __LINE__, fd, F_SETFL, 
+		      sflags & ~O_NONBLOCK);
+	  return (SL_TIMEOUT);
+	}
+
+      /*
+      tnow  = time(NULL);
+      tdiff = tnow - tstart;
+      */
 
       tv.tv_sec  = timeout - tdiff;
@@ -2673,15 +2160,13 @@
 	{
 	  byteread = read (fd, buf, count);
-
 	  if (byteread > 0) 
 	    {
 	      bytes += byteread; count -= byteread;
 	      buf += byteread;
-	      if (count == 0 || once == S_TRUE)
+	      if (count == 0)
 		break;
 	    }  
 	  else if (byteread == 0)
 	    {
-	      /* zero indicates end of file */
 	      break;
 	    }
@@ -2697,9 +2182,6 @@
 	      else
 		{
-		  error = errno;
-		  if (is_nonblocking == S_FALSE)
-		      retry_fcntl(FIL__, __LINE__, fd, F_SETFL, sflags);
-		  TPT(( 0, FIL__, __LINE__, _("msg=<read error>")));
-		  errno = error;
+		  retry_fcntl(FIL__, __LINE__, fd, F_SETFL, 
+			      sflags & ~O_NONBLOCK);
 		  return (SL_EREAD);
 		}
@@ -2715,86 +2197,20 @@
       else if (retval == 0)
 	{
-	  if (is_nonblocking == S_FALSE)
-	      retry_fcntl(FIL__, __LINE__, fd, F_SETFL, sflags);
-	  TPT(( 0, FIL__, __LINE__, _("msg=<timeout>")));
-	  errno = 0;
-	  if (bytes > 0)
-	    return ((int) bytes); 
+	  retry_fcntl(FIL__, __LINE__, fd, F_SETFL, 
+		      sflags & ~O_NONBLOCK);
 	  return (SL_TIMEOUT);
 	}
       else
 	{
-	  error = errno;
-	  if (is_nonblocking == S_FALSE)
-	      retry_fcntl(FIL__, __LINE__, fd, F_SETFL, sflags);
-	  TPT(( 0, FIL__, __LINE__, _("msg=<timeout>")));
-	  errno = error;
+	  retry_fcntl(FIL__, __LINE__, fd, F_SETFL, 
+		      sflags & ~O_NONBLOCK);
 	  return (SL_EREAD);
 	}
-
-      if (sig_termfast == 1) 
-	{
-	  if (is_nonblocking == S_FALSE)
-	      retry_fcntl(FIL__, __LINE__, fd, F_SETFL, sflags);
-	  TPT(( 0, FIL__, __LINE__, _("msg=<terminated>")));
-	  errno = 0;
-	  return (SL_EREAD);
-	}
-	  
       tnow  = time(NULL);
       tdiff = tnow - tstart;
-
-      if (tdiff > timeout)
-	{
-	  if (is_nonblocking == S_FALSE)
-	      retry_fcntl(FIL__, __LINE__, fd, F_SETFL, sflags);
-	  TPT(( 0, FIL__, __LINE__, _("msg=<timeout>")));
-	  errno = 0;
-	  if (bytes > 0)
-	    return ((int) bytes);
-	  return (SL_TIMEOUT);
-	}
-    }
-
-  if (is_nonblocking == S_FALSE)
-    retry_fcntl(FIL__, __LINE__, fd, F_SETFL, sflags);
+    }
+
+  retry_fcntl(FIL__, __LINE__, fd, F_SETFL, sflags & ~O_NONBLOCK);
   return ((int) bytes);
-}
-
-int sl_read_timeout_fd (int fd, void * buf_in, size_t count, 
-			int timeout, int is_nonblocking)
-{
-  return sl_read_timeout_fd_int (fd, buf_in, count, timeout, is_nonblocking, S_FALSE);
-}
-
-int sl_read_timeout_fd_once (int fd, void * buf_in, size_t count, 
-			int timeout, int is_nonblocking)
-{
-  return sl_read_timeout_fd_int (fd, buf_in, count, timeout, is_nonblocking, S_TRUE);
-}
-
-int sl_read_timeout (SL_TICKET ticket, void * buf_in, size_t count, 
-		     int timeout, int is_nonblocking)
-{
-  int    fd, retval;
- 
-  SL_ENTER(_("sl_read_timeout"));
-
-  if (buf_in == NULL || SL_ISERROR(fd = get_the_fd(ticket)))
-    {
-      if (buf_in == NULL)
-	{
-	  TPT(( 0, FIL__, __LINE__, _("msg=<null buffer>")));
-	  SL_IRETURN((SL_ENULL), _("sl_read_timeout"));
-	}
-      if (SL_ISERROR(fd = get_the_fd(ticket)))
-	{
-	  TPT(( 0, FIL__, __LINE__, _("msg=<ticket error> errno=<%d>"), fd));
-	  SL_IRETURN((fd),  _("sl_read_timeout"));
-	}
-    }
-
-  retval = sl_read_timeout_fd (fd, buf_in, count, timeout, is_nonblocking);
-  SL_IRETURN((retval), _("sl_read_timeout"));
 }
 
@@ -2808,15 +2224,13 @@
   char * buf;
 
-  SL_ENTER(_("sl_read"));
-
   if (count < 1)
     {
       TPT(( 0, FIL__, __LINE__, _("msg=<range error>")));
-      SL_IRETURN((SL_ERANGE), _("sl_read"));
+      return(SL_ERANGE);
     }
   if (buf_in == NULL)
     {
       TPT(( 0, FIL__, __LINE__, _("msg=<null buffer>")));
-      SL_IRETURN((SL_ENULL), _("sl_read"));
+      return (SL_ENULL);
     }
 
@@ -2824,5 +2238,5 @@
     {
       TPT(( 0, FIL__, __LINE__, _("msg=<ticket error> errno=<%d>"), fd));
-      SL_IRETURN((fd), _("sl_read"));
+      return (fd);
     }
 
@@ -2838,5 +2252,5 @@
 	}  
     } while ( byteread > 0 || 
-	      ( byteread == -1 && (errno == EINTR || errno == EAGAIN)) 
+	      ( byteread < 0 && (errno == EINTR || errno == EAGAIN)) 
 	      );
 
@@ -2845,7 +2259,7 @@
     {
       TPT(( 0, FIL__, __LINE__, _("msg=<read error> errno=<%d>\n"), errno));
-      SL_IRETURN((SL_EREAD), _("sl_read"));
-    }
-  SL_IRETURN((bytes), _("sl_read"));
+      return (SL_EREAD);
+    }
+  return (bytes);
 }
 
@@ -2857,15 +2271,13 @@
   char * buf;
 
-  SL_ENTER(_("sl_read_fast"));
-
   if (count < 1)
     {
       TPT(( 0, FIL__, __LINE__, _("msg=<range error>")));
-      SL_IRETURN((SL_ERANGE), _("sl_read_fast"));
+      return(SL_ERANGE);
     }
   if (buf_in == NULL)
     {
       TPT(( 0, FIL__, __LINE__, _("msg=<null buffer>")));
-      SL_IRETURN((SL_ENULL), _("sl_read_fast"));
+      return (SL_ENULL);
     }
 
@@ -2873,5 +2285,5 @@
     {
       TPT(( 0, FIL__, __LINE__, _("msg=<ticket error> errno=<%d>"), fd));
-      SL_IRETURN((fd), _("sl_read_fast"));
+      return (fd);
     }
 
@@ -2883,7 +2295,7 @@
       if (byteread >= 0) 
 	{
-	  SL_IRETURN((byteread), _("sl_read_fast"));
+	  return (byteread);
 	}  
-    } while ( byteread == -1 && (errno == EINTR || errno == EAGAIN));
+    } while ( byteread < 0 && (errno == EINTR || errno == EAGAIN));
 
  
@@ -2891,11 +2303,11 @@
     {
       TPT(( 0, FIL__, __LINE__, _("msg=<read error> errno=<%d>\n"), errno));
-      SL_IRETURN((SL_EREAD), _("sl_read_fast"));
-    }
-  SL_IRETURN((0), _("sl_read_fast"));
-}
-
-
-int sl_write (SL_TICKET ticket, const void * msg_in, long nbytes)
+      return (SL_EREAD);
+    }
+  return (0);
+}
+
+
+int sl_write (SL_TICKET ticket, void * msg_in, long nbytes)
 {
   long bytewritten;
@@ -2903,5 +2315,5 @@
   int  fd;
 
-  const char * msg; 
+  char * msg; 
 
   SL_ENTER(_("sl_write"));
@@ -2914,15 +2326,13 @@
     SL_IRETURN(fd, _("sl_write"));
 
-  msg = (const char *) msg_in;
+  msg = (char *) msg_in;
 
   /* write
    */
   bytecount    = 0;
-
+  bytewritten  = 0;
   while (bytecount < nbytes) 
     {    
-      bytewritten = write (fd, msg, nbytes-bytecount);
-
-      if (bytewritten > 0) 
+      if ((bytewritten = write (fd, msg, nbytes-bytecount)) > 0) 
 	{
 	  bytecount += bytewritten;
@@ -2940,5 +2350,5 @@
 }
 
-int sl_write_line (SL_TICKET ticket, const void * msg, long nbytes)
+int sl_write_line (SL_TICKET ticket, void * msg, long nbytes)
 {
   int  status;
@@ -2951,21 +2361,4 @@
 
   SL_IRETURN(status, _("sl_write_line"));
-}
-
-int sl_write_line_fast (SL_TICKET ticket, void * msg, long nbytes)
-{
-  int  status;
-  char * p = (char *) msg;
-
-  SL_ENTER(_("sl_write_line_fast"));
-
-  /* Here nbytes is strlen(msg), so p[nbytes] is the terminating '\0'
-   * Overwrite the terminator, write out, then write back the terminator.
-   */
-  p[nbytes] = '\n';
-  status = sl_write(ticket,  msg, nbytes+1);
-  p[nbytes] = '\0';
-
-  SL_IRETURN(status, _("sl_write_line_fast"));
 }
 
@@ -2978,93 +2371,65 @@
 
 extern uid_t rootonly[];
-extern unsigned int   EUIDSLOT;
-extern unsigned int   ORIG_EUIDSLOT;
+extern int   EUIDSLOT;
+extern int   ORIG_EUIDSLOT;
 
 extern char  tf_path[MAXFILENAME];	/* Error path for trust function. */
 extern uid_t tf_euid;	                /* Space for EUID of process.     */
 
+
 char * sl_error_string(int errorcode)
 {
-
   switch (errorcode)
     {
     case SL_EBOGUS: 
-      return _("Bogus file, modified during access");
+      return _("Bogus file. Modified during access.");
     case SL_EWRITE: 
-      return _("Write error");
+      return _("Write error.");
     case SL_EREAD: 
-      return _("Read error");
+      return _("Read error.");
     case SL_ESYNC: 
-      return _("Error in fsync()");
+      return _("Error in fsync().");
     case SL_EFORWARD: 
-      return _("Error in lseek()");
+      return _("Error in lseek().");
     case SL_EREWIND: 
-      return _("Error in lseek()");
+      return _("Error in lseek().");
     case SL_EUNLINK: 
-      return _("Error in unlink()");
+      return _("Error in unlink().");
     case SL_EMEM: 
-      return _("Out of memory");
+      return _("Out of memory.");
     case SL_EINTERNAL: 
-      return _("Internal error");
-    case SL_EINTERNAL01: 
-      return _("Internal error 01");
-    case SL_EINTERNAL02: 
-      return _("Internal error 02");
-    case SL_EINTERNAL03: 
-      return _("Internal error 03");
-    case SL_EINTERNAL04: 
-      return _("Internal error 04");
-    case SL_EINTERNAL05: 
-      return _("Internal error 05");
-    case SL_EINTERNAL06: 
-      return _("Internal error 06");
-    case SL_EINTERNAL07: 
-      return _("Internal error 07");
-    case SL_EINTERNAL08: 
-      return _("Internal error 08");
-    case SL_EINTERNAL09: 
-      return _("Internal error 09");
-    case SL_EINTERNAL10: 
-      return _("Internal error 10");
-    case SL_EINTERNAL11: 
-      return _("Internal error 11");
-    case SL_EINTERNAL12: 
-      return _("Internal error 12");
+      return _("Internal error.");
     case SL_ETICKET:
-      return _("Bad ticket");
+      return _("Bad ticket.");
     case SL_EREPEAT: 
-      return _("Illegal repeated use of function");
+      return _("Illegal repeated use of function.");
     case SL_ERANGE: 
-      return _("Argument out of range");
+      return _("Argument out of range.");
     case SL_ENULL: 
-      return _("Dereferenced NULL pointer");
+      return _("Dereferenced NULL pointer.");
 
     case SL_EBADUID: 
-      return _("Owner not trustworthy");
+      return _("Owner not trustworthy.");
     case SL_EBADGID:
-      return _("Group writeable and member not trustworthy");
+      return _("Group writeable and member not trustworthy.");
     case SL_EBADOTH:
-      return _("World writeable");
-    case SL_EISDIR:
-      return _("Is a directory");
+      return _("World writeable.");
     case SL_EBADFILE:
-      return _("File access error");
+      return _("File access error.");
     case SL_EBADNAME:
-      return _("Invalid filename (prob. too long or null)");
+      return _("Invalid filename (prob. too long or null).");
 
     case SL_ETRUNC:
-      return _("Truncation occured");
+      return _("Truncation occured.");
     case SL_ESTAT:
-      return _("stat() failed");
-    case SL_EFSTAT:
-      return _("fstat() failed");
+      return _("stat() failed.");
     default:
-      return _("Unknown error");
-    }
-}
-
-
-
-char * sl_trust_errfile(void)
+      return _("Unknown error.");
+    }
+}
+
+
+
+char * sl_trust_errfile()
 {
   return &tf_path[0];
@@ -3072,5 +2437,5 @@
 
 extern uid_t tf_baduid;
-uid_t   sl_trust_baduid(void)
+uid_t   sl_trust_baduid()
 {
   return tf_baduid;
@@ -3078,5 +2443,5 @@
 
 extern gid_t tf_badgid;
-gid_t   sl_trust_badgid(void)
+gid_t   sl_trust_badgid()
 {
   return tf_badgid;
@@ -3086,7 +2451,7 @@
 static int trust_count = 0;
 
-int  sl_trust_purge_user (void)
-{
-  unsigned int i;
+int  sl_trust_purge_user ()
+{
+  int i;
 
   EUIDSLOT = ORIG_EUIDSLOT;
@@ -3112,59 +2477,7 @@
 }
 
-#include "sh_mem.h"
-extern char * sh_util_strdup (const char * str);
-
-struct sl_trustfile_store {
-  char * filename;
-  uid_t  teuid;
-  struct sl_trustfile_store * next;
-};
-
-static struct sl_trustfile_store * sl_trusted_files = NULL;
-
-static void sl_add_trusted_file(const char * filename, uid_t teuid)
-{
-  struct sl_trustfile_store *new = SH_ALLOC(sizeof(struct sl_trustfile_store));
-
-  new->filename = sh_util_strdup (filename);
-  new->teuid    = teuid;
-  new->next     = sl_trusted_files;
-
-  sl_trusted_files = new;
-  return;
-}
-
-static const char * sl_check_trusted_file(const char * filename, uid_t teuid)
-{
-  struct sl_trustfile_store *new = sl_trusted_files;
-
-  while (new)
-    {
-      if ((new->teuid == teuid) && (0 == strcmp(new->filename, filename)))
-	return filename;
-      new = new->next;
-    }
-
-  return NULL;
-}
-
-static void sl_clear_trusted_file(struct sl_trustfile_store * file)
-{
-  if (file)
-    {
-      if (file->next != NULL)
-	sl_clear_trusted_file(file->next);
-      SH_FREE(file->filename);
-      SH_FREE(file);
-    }
-  return;
-}
-
-int sl_trustfile_euid(const char * filename, uid_t teuid)
-{
-  long          status;
-  static size_t old = 0;
-  static size_t now;
-
+int sl_trustfile_euid(char * filename, uid_t teuid)
+{
+  long status;
   SL_ENTER(_("sl_trustfile_euid"));
 
@@ -3173,103 +2486,8 @@
     SL_IRETURN(SL_EBADNAME, _("sl_trustfile_euid"));
 
-  now = time(NULL);
-
-  if (now < (old + 300))
-    {
-      if (NULL != sl_check_trusted_file(filename, teuid))
-	{
-	  sl_strlcpy(tf_path, filename, sizeof(tf_path));
-	  SL_IRETURN(SL_ENONE, _("sl_trustfile_euid"));
-	}
-    }
-  else
-    {
-      sl_clear_trusted_file(sl_trusted_files);
-      sl_trusted_files = NULL;
-      old = now;
-    }
-
   tf_euid = teuid;
   status = sl_trustfile(filename, NULL, NULL);
-  if (status == SL_ENONE)
-    sl_add_trusted_file(filename, teuid);
   SL_IRETURN(status, _("sl_trustfile_euid"));
 }
 
-/* ---------------------------------------------------------------- 
- *
- *    Overflow tests
- *
- * ---------------------------------------------------------------- */
-
-#ifndef SIZE_MAX
-#define SIZE_MAX              (4294967295U)
-#endif
-
-int sl_ok_muli (int a, int b) /* a*b */
-{
-  if ((b == 0) || (a >= (INT_MIN / b) && a <= (INT_MAX / b)))
-    return S_TRUE; /* no overflow */
-  return S_FALSE;
-}
-
-int sl_ok_muls (size_t a, size_t b) /* a*b */
-{
-  if ((b == 0) || (a <= (SIZE_MAX / b)))
-    return S_TRUE; /* no overflow */
-  return S_FALSE;
-}
-
-int sl_ok_divi (int a, int b) /* a/b */
-{
-  (void) a;
-  if (b != 0)
-    return S_TRUE; /* no overflow */
-  return S_FALSE;
-}
-
-int sl_ok_addi (int a, int b) /* a+b */
-{
-  if (a >= 0 && b >= 0)
-    {
-      if (a <= (INT_MAX - b))
-	return S_TRUE; /* no overflow */
-      else
-	return S_FALSE;
-    }
-  else if (a < 0 && b < 0)
-    {
-      if (a >= (INT_MIN - b))
-	return S_TRUE; /* no overflow */
-      else
-	return S_FALSE;
-    }
-  return S_TRUE;
-}
-
-int sl_ok_adds (size_t a, size_t b) /* a+b */
-{
-  if (a <= (SIZE_MAX - b))
-    return S_TRUE; /* no overflow */
-  else
-    return S_FALSE;
-}
-
-int sl_ok_subi (int a, int b) /* a-b */
-{
-  if (a >= 0 && b < 0)
-    {
-      if (a <= (INT_MAX + b))
-	return S_TRUE; /* no overflow */
-      else
-	return S_FALSE;
-    }
-  else if (a < 0 && b >= 0)
-    {
-      if (a >= (INT_MIN + b))
-	return S_TRUE; /* no overflow */
-      else
-	return S_FALSE;
-    }
-  return S_TRUE;
-}
+
